'Voronoi (11/18/2001 8:35:27 am)'.!


Voronoi2dDiagram subclass: #Delaunay2dDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voronoi-2d-Diagram'!

!Delaunay2dDiagram methodsFor: 'converting'!
asDelaunayDiagram
	^self! !

!Delaunay2dDiagram methodsFor: 'converting'!
asVoronoiDiagram
	^(Voronoi2dDiagram extent: self extent)
		addAll: self points; yourself! !


!Delaunay2dDiagram methodsFor: 'utilities'!
labelString
	^'Delaunay Diagram' copy! !


!Delaunay2dDiagram methodsFor: 'private'!
borderColor
	^Color cyan! !

!Delaunay2dDiagram methodsFor: 'private' stamp: 'nishis 5/16/98 00:37'!
makeImage
	| gc bounds factor points |
	voronoiProcessor := Voronoi2dProcessor dots: self points.
	processingCondition := voronoiProcessor compute.
	gc := Form extent: self extent depth: Display depth.
	bounds := gc boundingBox.
	gc fillWithColor: Color white.
	factor := self extent / (self extent + (1 @ 1)).
	voronoiProcessor 
			displayBorderOn: gc 
			box: (bounds insetBy: (0 @ 0 corner: 1 @ 1)) 
			lineWidth: 1 
			color: self borderColor.
	voronoiProcessor triangles
		do: 
			[:triangle | 
			points := Array
						with: ((triangle at: 1)
								scaleBy: factor) rounded
						with: ((triangle at: 2)
								scaleBy: factor) rounded
						with: ((triangle at: 3)
								scaleBy: factor) rounded.
			voronoiProcessor
				displayLoopOn: gc
				points: points
				clip: bounds
				lineWidth: 1 
				color: self triangleColor].
	diagramImage := gc. 
	^gc! !

!Delaunay2dDiagram methodsFor: 'private'!
triangleColor
	^Color magenta! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Delaunay2dDiagram class
	instanceVariableNames: ''!

!Delaunay2dDiagram class methodsFor: 'copyright'!
copyright
	^'Copyright 1991-1998 AOKI Atsushi'! !

!Delaunay2dDiagram class methodsFor: 'copyright'!
system
	^'Voronoi and Delaunay Diagram'! !

!Delaunay2dDiagram class methodsFor: 'copyright'!
version
	^'006'! !


!Delaunay2dDiagram class methodsFor: 'examples' stamp: 'nishis 5/15/98 03:17'!
example1
	"Delaunay2dDiagram example1."

	| diagram gc random view |
	diagram := Delaunay2dDiagram extent: 200 @ 200.
	view := ScheduledControllers activeController view.
	gc := Form extent: view insetDisplayBox extent depth: Display depth.
	gc fillWithColor: Color white.
	gc borderWidth: 2 color: Color black.
	random := Random new.
	50
		timesRepeat: 
			[diagram add: (random next @ random next scaleBy: diagram extent).
			diagram displayOn: gc.
			gc displayAt: view insetDisplayBox origin].
	Transcript cr; show: 'area: ' , diagram area rounded printString.
	gc displayAt: view insetDisplayBox origin.
	(Delay forMilliseconds: 1000) wait.
	view display.
	diagram show.
	^diagram! !

!Delaunay2dDiagram class methodsFor: 'examples' stamp: 'nishis 5/16/98 00:33'!
example2
	"Delaunay2dDiagram example2."

	| diagram random scheduledView displayView displayView2 |
	diagram := Delaunay2dDiagram extent: 200 @ 200.
	random := Random new.
	50 timesRepeat: [diagram add: (random next @ random next scaleBy: diagram extent)].
	Transcript cr; show: 'area: ' , diagram area rounded printString.

	scheduledView := AlteredScheduledView
		model: diagram
		label: 'Delaunay & Voronoi Diagram'
		minimumSize: 400 @ 200 + 4
		maximumSize: 400 @ 200 + 4.
	displayView := DisplayView model: (DisplayModel visual: diagram diagram).
	displayView controller: NoController new.
	scheduledView addSubView: displayView.
	displayView2 := DisplayView model: (DisplayModel visual: diagram asVoronoiDiagram diagram).
	displayView2 controller: NoController new.
	scheduledView addSubView: displayView2 toRightOf: displayView.
	scheduledView controller openAt: 100 @ 100.
	^diagram! !

!Delaunay2dDiagram class methodsFor: 'examples' stamp: 'nishis 5/24/98 08:52'!
example3
	"Delaunay2dDiagram example3."

	| string |
	string := 
'
	| diagram random window block process loop |
	diagram := Delaunay2dDiagram extent: 200 @ 200.
	random := Random new.
	window := ScheduledView new.
	window component: diagram.
	window label: diagram labelString.
	window minimumSize: diagram extent.
	window maximumSize: diagram extent.
	window openIn: (50 @ 50 extent: diagram extent).
	block := 
			[diagram add: (random next @ random next scaleBy: diagram extent).
			diagram displayOn: window graphicsContext.
			ScheduledControllers checkForEvents.
			Processor yield].
	process := nil.
	loop := true.
	diagram releaseBlock: [loop := false].
	process := [Object errorSignal
				handle: 
					[:exception | 
					process terminate.
					exception return]
				do: [[loop]
						whileTrue: [block value]]] newProcess.
	process priority: Processor activeProcess priority - 1.
	process resume.
	^diagram'.

	StringHolderView open: (StringHolder new contents: string) label:  'Delaunay2dDiagram example3'.! !

!Delaunay2dDiagram class methodsFor: 'examples' stamp: 'nishis 5/15/98 02:58'!
example4
	"This is a low precision example."
	"Delaunay2dDiagram example4."

	| diagram dots |
	diagram := Delaunay2dDiagram extent: 200 @ 200.
	dots := OrderedCollection new.
	dots add: 0.1 @ 0.1.
	dots add: 0.1 @ 0.9.
	dots add: 0.9 @ 0.1.
	dots add: 0.9 @ 0.9.
	dots add: 0.5 @ 0.5.
	dots add: 0.1 @ 0.5.
	dots add: 0.9 @ 0.5.
	dots add: 0.5 @ 0.1.
	dots add: 0.5 @ 0.9.
	dots do: [:dot | diagram add: (dot scaleBy: diagram extent)].
	Transcript cr; show: 'area: ' , diagram area rounded printString.
	diagram show.
	^diagram! !

!Delaunay2dDiagram class methodsFor: 'examples'!
example5
	"This is a low precision example."
	"Delaunay2dDiagram example5."

	| diagram count |
	diagram := Delaunay2dDiagram extent: 200 @ 200.
	count := 0.
	(0 to: 10 by: 1)
		do: [:y | (0 to: 10 by: 1)
				do: 
					[:x | 
					count even ifTrue: [diagram add: (x @ y / (10 @ 10) scaleBy: diagram extent)].
					count := count + 1]].
	Transcript cr; show: 'area: ' , diagram area rounded printString.
	diagram show.
	^diagram! !

!Delaunay2dDiagram class methodsFor: 'examples' stamp: 'nishis 5/15/98 03:00'!
example6
	"This is a low precision example."
	"Delaunay2dDiagram example6."

	| diagram dots step x y |
	diagram := Delaunay2dDiagram extent: 200 @ 200.
	dots := OrderedCollection new: 100.
	dots add: 0.0 @ 0.0.
	step := 10.
	(0 to: 360 by: step)
		do: 
			[:degrees | 
			x := degrees asFloat degreesToRadians cos.
			y := degrees asFloat degreesToRadians sin.
			dots add: x @ y.
			x := (degrees + (step / 2)) asFloat degreesToRadians cos.
			y := (degrees + (step / 2)) asFloat degreesToRadians sin.
			dots add: x @ y * (0.5 @ 0.5)].
	dots do: [:dot | diagram add: (dot + (1 @ 1) scaleBy: diagram extent / (2 @ 2))].
	Transcript cr; show: 'area: ' , diagram area rounded printString.
	diagram show.
	^diagram! !
