'Voronoi (11/18/2001 8:35:27 am)'.!


Object subclass: #Voronoi2dObject
	instanceVariableNames: ''
	classVariableNames: 'VoronoiDebugFlag '
	poolDictionaries: ''
	category: 'Voronoi-2d-Diagram'!
!Voronoi2dObject commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
2-Dimensional Voronoi and Delaunay Diagram
Goodies for Squeak 1.31, 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
2-Dimensional Voronoi and Delaunay Diagram
Free Software for VisualWorks 2.5
Copyright (c) 1991-1998 AOKI Atsushi
1998/02/02
http://www.sra.co.jp/people/aoki/Voronoi2dDiagram/Voronoi2.st
http://www.sra.co.jp/people/aoki/Voronoi2dDiagram/index.html
!


!Voronoi2dObject methodsFor: 'initialize-release'!
initialize
	"do nothing"! !


!Voronoi2dObject methodsFor: 'accessing'!
accuracy
	^self class accuracy! !

!Voronoi2dObject methodsFor: 'accessing'!
value
	^self! !


!Voronoi2dObject methodsFor: 'comparing'!
= anObject 
	^self == anObject! !


!Voronoi2dObject methodsFor: 'printing'!
printOn: aStream 
	| title |
	title := self class name.
	aStream nextPutAll: ((title at: 1) isVowel
			ifTrue: ['an ']
			ifFalse: ['a ']).
	aStream print: self class! !


!Voronoi2dObject methodsFor: 'debug' stamp: 'nishis 6/11/1998 22:44'!
debug: aBlock 
	| numberOfArguments aStream |
	VoronoiDebugFlag = true
		ifTrue: 
			[numberOfArguments := aBlock numArgs.
			numberOfArguments = 0
				ifTrue: [aBlock value]
				ifFalse: 
					[aStream := FileStream fileNamed: self debugFileName.
					aStream position: aStream size.
					aBlock value: aStream.
					aStream close]]! !

!Voronoi2dObject methodsFor: 'debug'!
debugFileName
	^'debug.txt' copy! !

!Voronoi2dObject methodsFor: 'debug' stamp: 'nishis 5/12/98 03:46'!
debugInitialize
	| aFilename |
	VoronoiDebugFlag = true
		ifTrue: 
			[aFilename := self debugFileName asFileName.
			FileDirectory default
					deleteFileNamed: aFilename ifAbsent: []]! !


!Voronoi2dObject methodsFor: 'error handling' stamp: 'nishis 5/14/98 03:02'!
error: aString
	^super error: aString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Voronoi2dObject class
	instanceVariableNames: ''!

!Voronoi2dObject class methodsFor: 'copyright'!
copyright
	^'Copyright 1991-1998 AOKI Atsushi'! !

!Voronoi2dObject class methodsFor: 'copyright'!
system
	^'Voronoi and Delaunay Diagram'! !

!Voronoi2dObject class methodsFor: 'copyright'!
version
	^'006'! !


!Voronoi2dObject class methodsFor: 'class initialization'!
initialize
	"Voronoi2dObject initialize."

	VoronoiDebugFlag := false! !


!Voronoi2dObject class methodsFor: 'instance creation'!
new
	^(super new) initialize; yourself! !


!Voronoi2dObject class methodsFor: 'accessing' stamp: 'nishis 5/12/98 03:23'!
accuracy
	^1.0e-10	"^1.0e-10"! !

!Voronoi2dObject class methodsFor: 'accessing'!
debug: aBoolean 
	"Voronoi2dObject debug: true."
	"Voronoi2dObject debug: false."

	VoronoiDebugFlag := aBoolean = true! !


!Voronoi2dObject class methodsFor: 'saving' stamp: 'nishis 5/11/98 04:27'!
propagateCopyright
	"Voronoi2dObject propagateCopyright."

	| copyright organizer top stream categories |
	copyright := self copyright.
	self saveClasses do: [:each | each = self
			ifFalse: 
				[organizer := each class organization.
				categories := organizer categories.
				categories isEmpty
					ifTrue: [top := nil]
					ifFalse: 
						[top := categories first.
						top = #copyright ifTrue: [categories size >= 2
								ifTrue: [top := categories at: 2]
								ifFalse: [top := nil]]].
				organizer addCategory: #copyright before: top.
				stream := WriteStream on: String new.
				stream nextPutAll: '!!'.
				stream nextPutAll: each name asString.
				stream nextPutAll: ' class methodsFor: '.
				stream nextPutAll: 'copyright' printString.
				stream nextPutAll: '!!'.
				stream cr.
				stream cr.
				stream nextPutAll: 'copyright'.
				stream cr.
				stream tab.
				stream nextPutAll: '^'.
				stream nextPutAll: copyright printString.
				stream nextPutAll: '!!'.
				stream cr.
				stream cr.
				stream nextPutAll: 'system'.
				stream cr.
				stream tab.
				stream nextPutAll: '^'.
				stream nextPutAll: self system printString.
				stream nextPutAll: '!!'.
				stream cr.
				stream cr.
				stream nextPutAll: 'version'.
				stream cr.
				stream tab.
				stream nextPutAll: '^'.
				stream nextPutAll: self version printString.
				stream nextPutAll: '!!'.
				stream nextPutAll: ' !!'.
				stream cr.
				(ReadWriteStream on: stream contents) fileIn]]! !

!Voronoi2dObject class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:43'!
save
	"Voronoi2dObject save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Voronoi2.st'.
	classCollection := self saveClasses.
	classCollection add: DisplayController.
	classCollection add: DisplayModel.
	classCollection add: DisplayView.
	classCollection add: ScheduledView.
	classCollection add: ScheduledController.
	classCollection add: AlteredScheduledView.
	classCollection add: AlteredScheduledController.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!Voronoi2dObject class methodsFor: 'saving'!
saveClasses
	"Voronoi2dObject saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Voronoi2d*' '*Delaunay2d*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


Voronoi2dObject initialize!
