'Voronoi (11/18/2001 8:35:30 am)'.!


Voronoi2dObject subclass: #Voronoi2dTriangle
	instanceVariableNames: 'dot1 dot2 dot3 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voronoi-2d-Diagram'!

!Voronoi2dTriangle methodsFor: 'initialize-release'!
initialize
	super initialize.
	dot1 := nil.
	dot2 := nil.
	dot3 := nil! !


!Voronoi2dTriangle methodsFor: 'accessing'!
dot1
	^dot1! !

!Voronoi2dTriangle methodsFor: 'accessing'!
dot1: voronoi2dDot 
	dot1 := Voronoi2dDot x: voronoi2dDot x y: voronoi2dDot y! !

!Voronoi2dTriangle methodsFor: 'accessing'!
dot2
	^dot2! !

!Voronoi2dTriangle methodsFor: 'accessing'!
dot2: voronoi2dDot 
	dot2 := Voronoi2dDot x: voronoi2dDot x y: voronoi2dDot y! !

!Voronoi2dTriangle methodsFor: 'accessing'!
dot3
	^dot3! !

!Voronoi2dTriangle methodsFor: 'accessing'!
dot3: voronoi2dDot 
	dot3 := Voronoi2dDot x: voronoi2dDot x y: voronoi2dDot y! !


!Voronoi2dTriangle methodsFor: 'functions'!
area
	^self areaWithSign abs! !

!Voronoi2dTriangle methodsFor: 'functions'!
areaWithSign
	| x1 y1 x2 y2 x3 y3 area |
	x1 := dot1 x.
	y1 := dot1 y.
	x2 := dot2 x.
	y2 := dot2 y.
	x3 := dot3 x.
	y3 := dot3 y.
	area := x2 * y3 + (x3 * y1) + (x1 * y2) - (x2 * y1) - (x3 * y2) - (x1 * y3) * 0.5.
	^area! !


!Voronoi2dTriangle methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: 'triangle ( '.
	dot1 printOn: aStream.
	aStream nextPutAll: ' , '.
	dot2 printOn: aStream.
	aStream nextPutAll: ' , '.
	dot3 printOn: aStream.
	aStream nextPutAll: ' )'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Voronoi2dTriangle class
	instanceVariableNames: ''!

!Voronoi2dTriangle class methodsFor: 'copyright'!
copyright
	^'Copyright 1991-1998 AOKI Atsushi'! !

!Voronoi2dTriangle class methodsFor: 'copyright'!
system
	^'Voronoi and Delaunay Diagram'! !

!Voronoi2dTriangle class methodsFor: 'copyright'!
version
	^'006'! !


!Voronoi2dTriangle class methodsFor: 'instance creation'!
dot: voronoi2dDot1 dot: voronoi2dDot2 dot: voronoi2dDot3 
	^(super new) dot1: voronoi2dDot1; dot2: voronoi2dDot2; dot3: voronoi2dDot3; yourself! !


!Voronoi2dTriangle class methodsFor: 'examples'!
example1
	"Voronoi2dTriangle example1."

	| triangle |
	triangle := Voronoi2dTriangle
				dot: (Voronoi2dDot x: 0 y: 0)
				dot: (Voronoi2dDot x: 1 y: 1)
				dot: (Voronoi2dDot x: 1 y: -1).
	^triangle! !

!Voronoi2dTriangle class methodsFor: 'examples'!
example2
	"Voronoi2dTriangle example2."

	| triangle areaWithSign area |
	triangle := Voronoi2dTriangle
				dot: (Voronoi2dDot x: 0 y: 0)
				dot: (Voronoi2dDot x: 2 y: 2)
				dot: (Voronoi2dDot x: 2 y: -2).
	areaWithSign := triangle areaWithSign.
	areaWithSign > 0
		ifTrue: [Transcript cr; show: areaWithSign printString , ' --- counterclockwise (ccw)']
		ifFalse: [Transcript cr; show: areaWithSign printString , ' --- clockwise (cw)'].
	triangle := Voronoi2dTriangle
				dot: (Voronoi2dDot x: 0 y: 0)
				dot: (Voronoi2dDot x: 2 y: -2)
				dot: (Voronoi2dDot x: 2 y: 2).
	areaWithSign := triangle areaWithSign.
	areaWithSign > 0
		ifTrue: [Transcript cr; show: areaWithSign printString , ' --- counterclockwise (ccw)']
		ifFalse: [Transcript cr; show: areaWithSign printString , ' --- clockwise (cw)'].
	area := triangle area.
	^area! !
