'Voronoi (11/18/2001 8:35:31 am)'.!


Voronoi2dObject subclass: #Voronoi2dDot
	instanceVariableNames: 'x y '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voronoi-2d-Diagram'!

!Voronoi2dDot methodsFor: 'initialize-release'!
initialize
	super initialize.
	x := nil.
	y := nil! !


!Voronoi2dDot methodsFor: 'accessing'!
x
	^x! !

!Voronoi2dDot methodsFor: 'accessing'!
x: aNumber 
	x := aNumber asFloat! !

!Voronoi2dDot methodsFor: 'accessing'!
y
	^y! !

!Voronoi2dDot methodsFor: 'accessing'!
y: aNumber 
	y := aNumber asFloat! !


!Voronoi2dDot methodsFor: 'functions'!
bisector: voronoi2dDot 
	| x1 y1 x2 y2 a b c |
	x1 := self x.
	y1 := self y.
	x2 := voronoi2dDot x.
	y2 := voronoi2dDot y.
	a := x2 - x1.
	b := y2 - y1.
	c := (x2 * x2 + (y2 * y2) - (x1 * x1 + (y1 * y1)) * 0.5) negated.
	(a abs < self accuracy and: [b abs < self accuracy])
		ifTrue: [^self error: 'two points are the same.'].
	^Voronoi2dLine
		a: a
		b: b
		c: c! !

!Voronoi2dDot methodsFor: 'functions'!
distance: voronoi2dDot 
	| x1 y1 x2 y2 x12 y12 |
	x1 := self x.
	y1 := self y.
	x2 := voronoi2dDot x.
	y2 := voronoi2dDot y.
	x12 := x1 - x2.
	y12 := y1 - y2.
	^(x12 * x12 + (y12 * y12)) sqrt! !


!Voronoi2dDot methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: 'dot ( '.
	x printOn: aStream.
	aStream nextPutAll: ' , '.
	y printOn: aStream.
	aStream nextPutAll: ' )'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Voronoi2dDot class
	instanceVariableNames: ''!

!Voronoi2dDot class methodsFor: 'copyright'!
copyright
	^'Copyright 1991-1998 AOKI Atsushi'! !

!Voronoi2dDot class methodsFor: 'copyright'!
system
	^'Voronoi and Delaunay Diagram'! !

!Voronoi2dDot class methodsFor: 'copyright'!
version
	^'006'! !


!Voronoi2dDot class methodsFor: 'instance creation'!
x: xNumber y: yNumber 
	^(super new) x: xNumber; y: yNumber; yourself! !


!Voronoi2dDot class methodsFor: 'examples'!
example1
	"Voronoi2dDot example1."

	| dot |
	dot := Voronoi2dDot x: 1 y: 1.
	^dot! !

!Voronoi2dDot class methodsFor: 'examples'!
example2
	"Voronoi2dDot example2."

	| dot1 dot2 distance |
	dot1 := Voronoi2dDot x: 0 y: 0.
	dot2 := Voronoi2dDot x: 1 y: 1.
	distance := dot1 distance: dot2.
	^distance! !

!Voronoi2dDot class methodsFor: 'examples'!
example3
	"Voronoi2dDot example3."

	| dot1 dot2 bisector |
	dot1 := Voronoi2dDot x: 0 y: 0.
	dot2 := Voronoi2dDot x: 1 y: 1.
	bisector := dot1 bisector: dot2.
	^bisector! !
