'Voronoi (11/18/2001 8:35:31 am)'.!


Voronoi2dDot subclass: #Voronoi2dPoint
	instanceVariableNames: 'side1 side2 side3 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voronoi-2d-Diagram'!

!Voronoi2dPoint methodsFor: 'initialize-release'!
initialize
	super initialize.
	side1 := nil.
	side2 := nil.
	side3 := nil! !


!Voronoi2dPoint methodsFor: 'accessing'!
side1
	^side1! !

!Voronoi2dPoint methodsFor: 'accessing'!
side1: voronoi2dSide 
	side1 := voronoi2dSide! !

!Voronoi2dPoint methodsFor: 'accessing'!
side2
	^side2! !

!Voronoi2dPoint methodsFor: 'accessing'!
side2: voronoi2dSide 
	side2 := voronoi2dSide! !

!Voronoi2dPoint methodsFor: 'accessing'!
side3
	^side3! !

!Voronoi2dPoint methodsFor: 'accessing'!
side3: voronoi2dSide 
	side3 := voronoi2dSide! !


!Voronoi2dPoint methodsFor: 'testing'!
isInvalid
	^self isValid not! !

!Voronoi2dPoint methodsFor: 'testing'!
isValid
	| boolean |
	boolean := true.
	x isNil ifTrue: [boolean := false].
	y isNil ifTrue: [boolean := false].
	side1 isNil
		ifTrue: [boolean := false]
		ifFalse: [side1 isValid2 ifFalse: [boolean := false]].
	side2 isNil
		ifTrue: [boolean := false]
		ifFalse: [side2 isValid2 ifFalse: [boolean := false]].
	side3 isNil
		ifTrue: [boolean := false]
		ifFalse: [side3 isValid2 ifFalse: [boolean := false]].
	^boolean! !


!Voronoi2dPoint methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: 'point ( '.
	x printOn: aStream.
	aStream nextPutAll: ' , '.
	y printOn: aStream.
	self
		debug: 
			[side1 isNil
				ifTrue: [aStream nextPutAll: ' , invalid side1']
				ifFalse: [side1 isValid2 ifFalse: [aStream nextPutAll: ' , invalid side1']].
			side2 isNil
				ifTrue: [aStream nextPutAll: ' , invalid side2']
				ifFalse: [side2 isValid2 ifFalse: [aStream nextPutAll: ' , invalid side2']].
			side3 isNil
				ifTrue: [aStream nextPutAll: ' , invalid side3']
				ifFalse: [side3 isValid2 ifFalse: [aStream nextPutAll: ' , invalid side3']]].
	aStream nextPutAll: ' )'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Voronoi2dPoint class
	instanceVariableNames: ''!

!Voronoi2dPoint class methodsFor: 'copyright'!
copyright
	^'Copyright 1991-1998 AOKI Atsushi'! !

!Voronoi2dPoint class methodsFor: 'copyright'!
system
	^'Voronoi and Delaunay Diagram'! !

!Voronoi2dPoint class methodsFor: 'copyright'!
version
	^'006'! !


!Voronoi2dPoint class methodsFor: 'examples'!
example1
	"Voronoi2dPoint example1."

	| point |
	point := Voronoi2dPoint x: 1 y: 1.
	^point! !

!Voronoi2dPoint class methodsFor: 'examples'!
example2
	"Voronoi2dPoint example2."

	| point1 point2 distance |
	point1 := Voronoi2dPoint x: 0 y: 0.
	point2 := Voronoi2dPoint x: 1 y: 1.
	distance := point1 distance: point2.
	^distance! !

!Voronoi2dPoint class methodsFor: 'examples'!
example3
	"Voronoi2dPoint example3."

	| point1 point2 bisector |
	point1 := Voronoi2dPoint x: 0 y: 0.
	point2 := Voronoi2dPoint x: 1 y: 1.
	bisector := point1 bisector: point2.
	^bisector! !
